<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.3                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2013                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_stats_article extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_stats_article';
        $this->info['title']            = 'Статистика просмотров и оценок - Статьи';
        $this->info['description']      = 'Для вывода уникальных просмотров. Выводятся и считаются такие параметры как IP, Дата просмотра, Логин просмотревшего\оценившего. Для удобства - список просмотревших новость был вынесен в модальное окно.';
        $this->info['author']           = 'InstantCMS Team, Денис Гоновичев - goodmade.ru';
        $this->info['version']          = '1.0';

        // Настройки по-умолчанию
        
   
                $this->config['Статистика просмотров']          = 1;
                  $this->config['Статистика оценок']          = 1;
                        $this->config['Статистика просмотров - Только зарегистрированные']          = 1;
                
        

        // События, которые будут отлавливаться плагином

      $this->events[]                 = 'GET_ARTICLE';
    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){
     $inCore     = cmsCore::getInstance();       //подключаем ядро
        $inDB       = cmsDatabase::getInstance();   //подключаем базу данных
        $inConf     = cmsConfig::getInstance();

        include($_SERVER['DOCUMENT_ROOT'].'/includes/dbimport.inc.php');

        dbRunSQL($_SERVER['DOCUMENT_ROOT'].'/plugins/p_stats_article/sql.sql', $inConf->db_prefix);

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event='', $item=array()){

        parent::execute();

        switch ($event){
            case 'GET_ARTICLE': $item = $this->eventGetStats($item); break;
        }

        return $item;


    }


    private function eventGetStats($item) {
echo '<script src="/plugins/p_stats_article/js/common.js" type="text/javascript"></script>';
echo '<link href="/plugins/p_stats_article/styles.css" rel="stylesheet" type="text/css" />';
echo '<link href="/templates/_default_/css/nyromodal.css" rel="stylesheet" type="text/css" />';
echo '<script src="/templates/_default_/js/nyromodal.js" type="text/javascript"></script>';
        $inDB = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();
        function getRealIpAddr()
{
  if (!empty($_SERVER['HTTP_CLIENT_IP']))
  {
    $ip=$_SERVER['HTTP_CLIENT_IP'];
  }
  elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
  {
    $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
  }
  else
  {
    $ip=$_SERVER['REMOTE_ADDR'];
  }
  return $ip;
}

$id=$item['id'];

    $target="content";
    $target_num=1;

if($this->config['Статистика просмотров']){
     $ip=getRealIpAddr();
    
 

    $item['hits']=$inDB->rows_count('cms_hits',"item_id=$id AND target='$target'");
    
    if($this->config['Статистика просмотров - Только зарегистрированные']){
          $userhits=$inDB->get_field('cms_hits',"item_id=$id AND target='$target' AND user_id={$inUser->id}",'id');
    if(!$userhits and $inUser->id){
    $inDB->query("INSERT INTO cms_hits SET item_id=$id, ip='$ip', target='$target', user_id={$inUser->id}, pubdate=NOW()");
    }
    }else{
         $userhits=$inDB->get_field('cms_hits',"item_id=$id AND target='$target' AND ip='$ip'",'id');
    if(!$userhits){
    $inDB->query("INSERT INTO cms_hits SET item_id=$id, ip='$ip', target='$target', user_id={$inUser->id}, pubdate=NOW()");
    }   
    }
    
    $item['hits_stat']='- <a href="#" OnClick="javascript:whoVotes('.$id.','.$target_num.',1);return false" class="statlink">Кто читал?</a>';
}
if($this->config['Статистика оценок']){
$item['votes_stat']='- <a href="#" OnClick="javascript:whoVotes('.$id.','.$target_num.',2);return false" class="statlink">Кто оценил?</a>';
}




        return $item;

    }
// ==================================================================== //

}

?>
